<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/Billboard.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_billboard_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Billboard.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_billboard_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef _H_Billboard_</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define _H_Billboard_</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_mat_8hpp.html">Mat.hpp</a>&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_camera_8hpp.html">Camera.hpp</a>&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_transform_8hpp.html">Transform.hpp</a>&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_billboard_transform_8hpp.html">BillboardTransform.hpp</a>&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_scene_8hpp.html">Scene.hpp</a>&quot;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_material_8hpp.html">Material.hpp</a>&quot;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_triangle_8hpp.html">Triangle.hpp</a>&quot;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="class_billboard.html">   21</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_billboard.html">Billboard</a> {</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <a class="code" href="class_billboard_transform.html">BillboardTransform</a> *bb_tf1;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <a class="code" href="class_transform.html">Transform</a> *bb_tf2;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <a class="code" href="class_material.html">Material</a> *m;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <a class="code" href="class_triangle.html">Triangle</a>* t1;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <a class="code" href="class_triangle.html">Triangle</a> *t2;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <a class="code" href="class_triangle.html">Triangle</a>* t3;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <a class="code" href="class_triangle.html">Triangle</a> *t4;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="class_billboard.html#ab27ce66552535bfb5d2f823f555dde56">   43</a></span>&#160;    std::string <a class="code" href="class_billboard.html#ab27ce66552535bfb5d2f823f555dde56">uid</a>;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="class_billboard.html#ab3ec3cd19e91a85426a66070095ed243">   46</a></span>&#160;    <a class="code" href="class_camera.html">Camera</a>* <a class="code" href="class_billboard.html#ab3ec3cd19e91a85426a66070095ed243">camera</a>;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    </div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="comment">// This constructor reads the texture from a file, which can be expensive if many billboards</span></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="comment">// are to be used. If that is the case, then consider using the alternative constructor.</span></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="comment"></span>    <a class="code" href="class_billboard.html#a66d24fc23c054419387c9c5794cd6951">Billboard</a> (<span class="keywordtype">double</span> dx, <span class="keywordtype">double</span> dy, <span class="keywordtype">double</span> dz, <span class="keywordtype">double</span> scale_x, <span class="keywordtype">double</span> scale_y, <span class="keywordtype">double</span> scale_z, <a class="code" href="class_scene.html">Scene</a>* scene, <a class="code" href="class_camera.html">Camera</a>* camera, <span class="keyword">const</span> <span class="keywordtype">char</span> *filename);</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="comment">//  This constructor receives a pointer to a material. You can use the material already defined in another </span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="comment">//  billboard by accessing its &#39;m&#39; attribute.</span></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment"></span>    <a class="code" href="class_billboard.html#a66d24fc23c054419387c9c5794cd6951">Billboard</a> (<span class="keywordtype">double</span> dx, <span class="keywordtype">double</span> dy, <span class="keywordtype">double</span> dz, <span class="keywordtype">double</span> scale_x, <span class="keywordtype">double</span> scale_y, <span class="keywordtype">double</span> scale_z, <a class="code" href="class_scene.html">Scene</a>* scene, <a class="code" href="class_camera.html">Camera</a>* camera, <a class="code" href="class_material.html">Material</a> *m);</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    </div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno"><a class="line" href="class_billboard.html#acf92777d2fda920b2b64625aa450bd3c">   84</a></span>&#160;    <a class="code" href="class_material.html">Material</a>* <a class="code" href="class_billboard.html#acf92777d2fda920b2b64625aa450bd3c">getMaterial</a>() {<span class="keywordflow">return</span> m;}</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_billboard.html#a3c39b6f8b74eab1252daa939856bf314">setMaterial</a>(<a class="code" href="class_material.html">Material</a> *_m);</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno"><a class="line" href="class_billboard.html#ae57727f59f1ce912cb9884289c5e36a7">   96</a></span>&#160;    <a class="code" href="class_transform.html">Transform</a>* <a class="code" href="class_billboard.html#ae57727f59f1ce912cb9884289c5e36a7">getTransform</a>() {<span class="keywordflow">return</span> bb_tf1;}</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno"><a class="line" href="class_billboard.html#a71045dffcdb7bf62c8e3534dc6d5e0eb">  102</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_billboard.html#a71045dffcdb7bf62c8e3534dc6d5e0eb">setAlignVertical</a>(<span class="keywordtype">bool</span> _align){bb_tf1-&gt;<a class="code" href="class_billboard_transform.html#a4d49ea1957972293f8c4c25e9c63141c">setAlignVertical</a>(_align);}</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="class_billboard.html#a23e233cc3b365c63ad341823bbb51087">  108</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_billboard.html#a23e233cc3b365c63ad341823bbb51087">getAlignVertical</a>(){<span class="keywordflow">return</span> bb_tf1-&gt;<a class="code" href="class_billboard_transform.html#a064e3a5f3933b74ab225aec1ad45882e">getAlignVertical</a>();}</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="keywordtype">void</span> createBillboard(<span class="keywordtype">double</span> dx, <span class="keywordtype">double</span> dy, <span class="keywordtype">double</span> dz, <span class="keywordtype">double</span> scale_x, <span class="keywordtype">double</span> scale_y, <span class="keywordtype">double</span> scale_z, <a class="code" href="class_scene.html">Scene</a>* scene, <a class="code" href="class_camera.html">Camera</a>* camera);</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;};</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="class_triangle_html"><div class="ttname"><a href="class_triangle.html">Triangle</a></div><div class="ttdoc">A class to create and manipulate triangles. </div><div class="ttdef"><b>Definition:</b> Triangle.hpp:16</div></div>
<div class="ttc" id="class_billboard_html_a71045dffcdb7bf62c8e3534dc6d5e0eb"><div class="ttname"><a href="class_billboard.html#a71045dffcdb7bf62c8e3534dc6d5e0eb">Billboard::setAlignVertical</a></div><div class="ttdeci">void setAlignVertical(bool _align)</div><div class="ttdoc">State whether the billboard should always be vertically aligned (true by default) ...</div><div class="ttdef"><b>Definition:</b> Billboard.hpp:102</div></div>
<div class="ttc" id="class_camera_html"><div class="ttname"><a href="class_camera.html">Camera</a></div><div class="ttdoc">A class to create and manipulate virtual projective cameras. </div><div class="ttdef"><b>Definition:</b> Camera.hpp:20</div></div>
<div class="ttc" id="class_billboard_transform_html_a064e3a5f3933b74ab225aec1ad45882e"><div class="ttname"><a href="class_billboard_transform.html#a064e3a5f3933b74ab225aec1ad45882e">BillboardTransform::getAlignVertical</a></div><div class="ttdeci">bool getAlignVertical()</div><div class="ttdoc">Return true if the billboard has been setup to be always vertically aligned (true by default) ...</div><div class="ttdef"><b>Definition:</b> BillboardTransform.hpp:76</div></div>
<div class="ttc" id="class_transform_html"><div class="ttname"><a href="class_transform.html">Transform</a></div><div class="ttdoc">A class to handle rigid transformations. </div><div class="ttdef"><b>Definition:</b> Transform.hpp:17</div></div>
<div class="ttc" id="class_billboard_html"><div class="ttname"><a href="class_billboard.html">Billboard</a></div><div class="ttdoc">A class to handle Billboards of simple textures. The billboard is composed of two quads rotated 90 de...</div><div class="ttdef"><b>Definition:</b> Billboard.hpp:21</div></div>
<div class="ttc" id="class_material_html"><div class="ttname"><a href="class_material.html">Material</a></div><div class="ttdoc">A class to create and manipulate surface materials. </div><div class="ttdef"><b>Definition:</b> Material.hpp:19</div></div>
<div class="ttc" id="_billboard_transform_8hpp_html"><div class="ttname"><a href="_billboard_transform_8hpp.html">BillboardTransform.hpp</a></div></div>
<div class="ttc" id="class_billboard_html_a66d24fc23c054419387c9c5794cd6951"><div class="ttname"><a href="class_billboard.html#a66d24fc23c054419387c9c5794cd6951">Billboard::Billboard</a></div><div class="ttdeci">Billboard(double dx, double dy, double dz, double scale_x, double scale_y, double scale_z, Scene *scene, Camera *camera, const char *filename)</div><div class="ttdoc">A BillboardTransform constructor properly initialised from position and scale data. </div><div class="ttdef"><b>Definition:</b> Billboard.cpp:8</div></div>
<div class="ttc" id="class_scene_html"><div class="ttname"><a href="class_scene.html">Scene</a></div><div class="ttdoc">A class to create and control scenes from Surface and Light objects. </div><div class="ttdef"><b>Definition:</b> Scene.hpp:23</div></div>
<div class="ttc" id="class_billboard_html_acf92777d2fda920b2b64625aa450bd3c"><div class="ttname"><a href="class_billboard.html#acf92777d2fda920b2b64625aa450bd3c">Billboard::getMaterial</a></div><div class="ttdeci">Material * getMaterial()</div><div class="ttdoc">Returns a pointer to the Material associated to this Billboard. </div><div class="ttdef"><b>Definition:</b> Billboard.hpp:84</div></div>
<div class="ttc" id="class_billboard_transform_html_a4d49ea1957972293f8c4c25e9c63141c"><div class="ttname"><a href="class_billboard_transform.html#a4d49ea1957972293f8c4c25e9c63141c">BillboardTransform::setAlignVertical</a></div><div class="ttdeci">void setAlignVertical(bool _align)</div><div class="ttdoc">State whether the billboard should always be vertically aligned (true by default) ...</div><div class="ttdef"><b>Definition:</b> BillboardTransform.hpp:70</div></div>
<div class="ttc" id="class_billboard_html_a23e233cc3b365c63ad341823bbb51087"><div class="ttname"><a href="class_billboard.html#a23e233cc3b365c63ad341823bbb51087">Billboard::getAlignVertical</a></div><div class="ttdeci">bool getAlignVertical()</div><div class="ttdoc">Return true if the billboard has been setup to be always vertically aligned (true by default) ...</div><div class="ttdef"><b>Definition:</b> Billboard.hpp:108</div></div>
<div class="ttc" id="class_billboard_html_ab3ec3cd19e91a85426a66070095ed243"><div class="ttname"><a href="class_billboard.html#ab3ec3cd19e91a85426a66070095ed243">Billboard::camera</a></div><div class="ttdeci">Camera * camera</div><div class="ttdoc">A pointer to the camera. </div><div class="ttdef"><b>Definition:</b> Billboard.hpp:46</div></div>
<div class="ttc" id="class_billboard_transform_html"><div class="ttname"><a href="class_billboard_transform.html">BillboardTransform</a></div><div class="ttdoc">A class to handle Billboard transformations. </div><div class="ttdef"><b>Definition:</b> BillboardTransform.hpp:17</div></div>
<div class="ttc" id="_transform_8hpp_html"><div class="ttname"><a href="_transform_8hpp.html">Transform.hpp</a></div></div>
<div class="ttc" id="_triangle_8hpp_html"><div class="ttname"><a href="_triangle_8hpp.html">Triangle.hpp</a></div></div>
<div class="ttc" id="class_billboard_html_ab27ce66552535bfb5d2f823f555dde56"><div class="ttname"><a href="class_billboard.html#ab27ce66552535bfb5d2f823f555dde56">Billboard::uid</a></div><div class="ttdeci">std::string uid</div><div class="ttdoc">A unique identififier for this transform. </div><div class="ttdef"><b>Definition:</b> Billboard.hpp:43</div></div>
<div class="ttc" id="class_billboard_html_a3c39b6f8b74eab1252daa939856bf314"><div class="ttname"><a href="class_billboard.html#a3c39b6f8b74eab1252daa939856bf314">Billboard::setMaterial</a></div><div class="ttdeci">void setMaterial(Material *_m)</div><div class="ttdoc">Sets the material for this Billboard. </div><div class="ttdef"><b>Definition:</b> Billboard.cpp:42</div></div>
<div class="ttc" id="_material_8hpp_html"><div class="ttname"><a href="_material_8hpp.html">Material.hpp</a></div></div>
<div class="ttc" id="_mat_8hpp_html"><div class="ttname"><a href="_mat_8hpp.html">Mat.hpp</a></div></div>
<div class="ttc" id="class_billboard_html_ae57727f59f1ce912cb9884289c5e36a7"><div class="ttname"><a href="class_billboard.html#ae57727f59f1ce912cb9884289c5e36a7">Billboard::getTransform</a></div><div class="ttdeci">Transform * getTransform()</div><div class="ttdoc">Returns a pointer to the BillboardTransform node associated to this Billboard. </div><div class="ttdef"><b>Definition:</b> Billboard.hpp:96</div></div>
<div class="ttc" id="_scene_8hpp_html"><div class="ttname"><a href="_scene_8hpp.html">Scene.hpp</a></div></div>
<div class="ttc" id="_camera_8hpp_html"><div class="ttname"><a href="_camera_8hpp.html">Camera.hpp</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_billboard_8hpp.html">Billboard.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
